#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <FCNTL.H>
#include <SYS\STAT.H>
#include <malloc.h>

#include <windows.h>
#include "audio.h"
#include "AY-3-8912.c"
#include "sound.c"

int data_sample_rate = 44100;

int throttle = 1;       // throttle , auto-frame-skip?

                        // 0 = left  \_ sound output
int channel = 0;        // 1 = right /  (no, its not stereo, i just want more volume)

FILE *PSG_file = NULL;
int PSG_file_handle = -1;
unsigned char *PSG_data;
unsigned char *PSG_data_glb;
unsigned char *PSGBuff;
unsigned char *PSG_buffer;

void main(int argc, char *argv[])
{   
    long PSG_file_length = 0;
    long PSG_data_pos = 0;
    int PSG_register = 0;
    int PSG_value = 0;
    int buffer_size = 726;    
    int loop = 0;
	int hitkey = 0;
	int Buff_Pos = 0;
    if (argc != 2)
    {
        printf("\n PSGPlay32!\n");
        printf("\n Use : PSGPlay32 <.PSG file>\n");
        exit(0);
    }

	// little messages
    printf("\n # PSGPlay32\n");    
    
    // initialize Seal and the sound hardware
    msdos_init_seal();
    msdos_init_sound();

    printf(" # Seal Audio Initialized!\n");    

    ///////////////////////////////////////////////////////////////
    // Load the PSG file into memory
    ///////////////////////////////////////////////////////////////
    
	PSG_file_handle = _open(argv[1], _O_RDONLY | _O_BINARY,_S_IREAD);
    if (PSG_file_handle == -1)
    {
        printf("\nERROR:\tFILE DOES NOT EXIST\n");
        exit(0);
    }
    PSG_file_length = filelength(PSG_file_handle);
    PSG_data_glb = GlobalAlloc(GPTR, (long)PSG_file_length);    
	PSG_data = GlobalLock(PSG_data_glb);
    _read(PSG_file_handle, PSG_data, PSG_file_length);
    _close(PSG_file_handle);
	printf(" # PSG File Loaded!\n");
    
    ///////////////////////////////////////////////////////////////
    // Initialize the Chip
    ///////////////////////////////////////////////////////////////
        
	// This buffer was not getting initialised anywhere!  (At lease I couldn't find it, so
	// I decided to do it here...
	if (sizeof(PSG_buffer)<buffer_size)
	{
		PSGBuff = GlobalAlloc(GPTR, (long)buffer_size);
		PSG_buffer=GlobalLock(PSGBuff);	//malloc(buffer_size);
	}
    // PSGInit( hz rate, sample rate, sample bit, buffer size, ym buffer)
    PSGInit((double)3750000, data_sample_rate, 8, buffer_size, PSG_buffer);
    // reset chip 
    PSGResetChip();
    printf(" # PSG Initialized & Ready!\n");
    
    printf(" # Playing! - Press any key to Quit!\n");
    
    ///////////////////////////////////////////////////////////////
    
    //while (!key[KEY_ESC] && cym_data_pos < cym_file_length)
    while (PSG_data_pos < PSG_file_length && (!(hitkey==27)))
    {        
        // 0x00 // VBLANK // UPDATE //
        if ((PSG_data[PSG_data_pos] == 0xFF) || Buff_Pos==buffer_size)
        {
            // channel   = 0 = left
            // channel+1 = 1 = right
	
            PSGUpdate();
			Sleep(2);

			//if (Buff_Pos==buffer_size-1)
			//{
				// filter to be applied - heaven knows why?! - probably does nothing actually!
				//apply_RC_filter(channel, (signed char *)PSG_buffer, buffer_size, data_sample_rate);
				//apply_RC_filter_16(channel+1, (signed short *)PSG_buffer, buffer_size, data_sample_rate);
				// streams my channel (voice) - "buffer_size * 2" data is needed to stop running over end!
				osd_play_streamed_sample(channel, (signed char *)PSG_buffer, buffer_size , data_sample_rate, 255, 0);
				osd_play_streamed_sample(channel+1, (signed char *)PSG_buffer, buffer_size , data_sample_rate, 255, 127);
				//printf("osd_play_streamed_sample\n");
            
				PSG_data_pos++;
				//Buff_Pos=0;
			//}
		}
		else
		{
            PSG_register = PSG_data[PSG_data_pos];
            PSG_data_pos++;
            PSG_value = PSG_data[PSG_data_pos];
            PSGWriteReg(PSG_register, PSG_value);
            PSG_data_pos++;
			//PSGUpdateBuf(Buff_Pos);
			//Buff_Pos++;
		}

		hitkey=_kbhit();
		if (!(hitkey==0))
		{
			hitkey=27;
		}
    }

	GlobalUnlock(PSG_buffer);
	GlobalFree(PSGBuff);

	GlobalUnlock(PSG_data);
	GlobalFree(PSG_data_glb);

    // shutdown eveything and exit
    PSGShutdown();
    exit(0);

}